; This code provides informative error messages
;   for SSAX (S)XML parser.
;
;
; NOTE: Bigllo-specific ! 
; It was tested with SSAX version 4.5 / Bigloo 2.2b
;
; $Id: ssax-error.scm,v 1.1 2001/03/06 20:10:15 kl Exp kl $


;;;; Error handler

;;; According to the SSAX convention this function
;;; accepts the port as its first argument which is used for
;;; location of the error in input file.
;;; Other parameters are considered as error messages,
;;;  they are printed to stderr as is.
(define parser-error
  (lambda  args
    (if
      (port? (car args))
      (begin
	(cerr nl "Error: " (input-port-name (car args)))
	(cerr " at position " (input-port-position (car args)) nl)
	(cerr (cdr args)))
      (cerr nl "Error in error handler :-) " nl args))
    (cerr nl)
    (exit -1)))

(define SSAX:warn
  (lambda  args
    (if
      (port? (car args))
	(cerr nl "Warning: " (input-port-name (car args))
	      " at position " (input-port-position (car args)) nl
	      (cdr args) nl)
	#f)
    ))
